/* ------------------------------------------------ */
vm= 'Monitor for APC Back-UPS CS/ES (USB) v 0.04b'
/* ------------------------------------------------ */
/*                        15.06.2006 (c) Larin Yury */

/* set constants */
ddName           = 'UPS$'       /* set device driver name */

/* ----------------------------------------- */
if RxFuncQuery('SysLoadFuncs') then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
 end
/* ----------------------------------------- */
call SysCls
say vm
say
say 'Show status of UPS'
say


/* ensure that the device driver statement exists in config.sys */
if stream(ddName,'command','query exists') \= '\DEV\' || ddName
then do
  say 'Missing DEVICE=x:\OS2\BOOT\USBECD.SYS /N:'||ddName 'statement in CONFIG.SYS.'
  say
  say 'Press any key to close...'
  Key = SysGetKey('NOECHO')
  exit
 end

rc=stream(ddName,'command','open')

if rc \= 'READY:' then do
   say 'Device driver' ddName 'currently in use. Please try later.'
   say
   say 'Press any key to close...'
   Key = SysGetKey('NOECHO')
  end
 else do

  oiBuffer = ReadUPS(x2c('80 06 00 01 00 00 12'), 26, 17)
  say 'Found on device driver' ddName':'
  say 'Manufacturer             -- 'disp(15)
  say 'Product                  -- 'disp(16)
  say 'Serial Number            -- 'disp(17)

  oiBuffer = ReadUPS(x2c('a1 01 1c 03 00 00 07'), 15, 6)
  say 'Battery Replacement Date -- 'c2x(substr(oiBuffer,3,1))'-'c2x(substr(oiBuffer,2,1))'-20'c2x(substr(oiBuffer,4,1))

  oiBuffer = ReadUPS(x2c('a1 01 0c 03 00 00 07'), 15, 6)
  say 'Current battery capacity -- 'c2d(substr(oiBuffer,2,1))'%'
  say 'Estimate run time        -- 'x2d(c2x(substr(oiBuffer,6,1))||c2x(substr(oiBuffer,5,1)))' sec.'

  PS = c2x(ReadUPS(x2c('a1 01 13 03 00 00 07'), 15, 2))
  select
   when PS = 1301 then PSS = 'good'
   when PS = 1300 then PSS = 'fails'
   otherwise PSS = 'Error reading data!!! (PS = 'PS')'
  end
  say 'AC utility power source  -- 'PSS

  SF1 = ReadUPS(x2c('a1 01 06 03 00 00 07'), 15, 4)
  SF = substr(SF1,4,1)
  select
   when SF = '08'x then SFS = 'Working from AC power.'
   when SF = '10'x then SFS = 'Working from battery, battery capacity OK.'
   when SF = '50'x then SFS = 'Working from baterry, battery capacity LOW.'
   otherwise SFS = 'Error reading data!!! (SF = 'c2x(SF)')'
  end
  say 'APC Status Flag          -- 'SFS

  if substr(SF1,2,1) = '01'x then say right('Battery is charging.',48)
  if substr(SF1,3,1) = '01'x then say right('Battery is discharging.',51)

  PSF = ReadUPS(x2c('a1 01 09 03 00 00 07'), 15, 3)
  if left(PSF,1) = '09'x then Power = c2d(right(PSF, 1)||substr(PSF, 2, 1))||' ('format(c2d(right(PSF, 1)||substr(PSF, 2, 1)) * 1.73,,0)') CentiVolts'
    else Power = 'Error reading data!!! (PSF = 'c2x(PSF)')'
  say 'AC power voltage         -- 'Power

  rc=stream(ddName,'command','close')
 end

say
say 'Press any key to close...'
Key = SysGetKey('NOECHO')
exit

/* ----------------------------------------- */
ReadUPS:
 oiBuffer1 = left(arg(1), arg(2), x2c(00))
 rc=charout(ddName,oiBuffer1)
 rc=stream(ddName,'description')
 if rc \= 'READY:' then do
  parse value rc with sState ':' mNumber
  say SysGetMessage(mNumber,,ddName)
  say
  say 'Press any key to close...'
  Key = SysGetKey('NOECHO')
  exit
 end
return substr(oiBuffer1,9,arg(3))

disp:
 ixString = substr(oiBuffer, arg(1), 1)
 if c2d(ixString) = 0 then return 'No String!'

 siBuffer = left(x2c('80 06 00 03 09 04 01'),9,x2c(00))
 siBuffer = overlay(ixString,siBuffer,3)
 rc=charout(ddName,siBuffer)
 rc=stream(ddName,'description')
 if rc \= 'READY:' then do
   /* obtain and issue error message */
   parse value rc with sState ':' mNumber
   if mNumber == 95 /* character i/o call interrupted */
   then RETURN "I/O canceled (4 seconds time-out) ..."
   else RETURN 'String Error! ('rc')'
  end

 szBuffer = substr(siBuffer,9,1)
 if c2d(szBuffer) = 0 then return 'No String!'

 siBuffer = overlay(szBuffer,siBuffer,7,c2d(szBuffer)+2,x2c(00))
 rc=charout(ddName,siBuffer)
 rc=stream(ddName,'description')
 if rc \= 'READY:' then return 'String Error!'

 szString=c2d(substr(siBuffer,9,1)) + 8
 usString = ''
 do xPos = 11 to szString by 2
  usString = usString || substr(siBuffer,xPos,1)
 end
return usString
